//
// fakedll (for BotMixer5000 - botman's multibot loader)
//
// (http://planethalflife.com/botman/)
//
// dll.cpp
//

#include "extdll.h"
#include "enginecallback.h"
#include "util.h"
#include "cbase.h"

#include "fakedll.h"

GETENTITYAPI master_GetFakeDLLEntityAPI = NULL;
MASTERFAKECLIENTCOMMAND master_MasterFakeClientCommand = NULL;
DLL_FUNCTIONS pFakeDLLFunctionTable;

extern BotLibrary h_Library;
extern char *g_argv;


void GameDLLInit( void )
{
   return;
}

int DispatchSpawn( edict_t *pent )
{
   return 0;
}

void DispatchThink( edict_t *pent )
{
   return;
}

void DispatchUse( edict_t *pentUsed, edict_t *pentOther )
{
   return;
}

void DispatchTouch( edict_t *pentTouched, edict_t *pentOther )
{
   return;
}

void DispatchBlocked( edict_t *pentBlocked, edict_t *pentOther )
{
   return;
}

void DispatchKeyValue( edict_t *pentKeyvalue, KeyValueData *pkvd )
{
   return;
}

void DispatchSave( edict_t *pent, SAVERESTOREDATA *pSaveData )
{
   return;
}

int DispatchRestore( edict_t *pent, SAVERESTOREDATA *pSaveData, int globalEntity )
{
   return 0;
}

void DispatchObjectCollsionBox( edict_t *pent )
{
   return;
}

void SaveWriteFields( SAVERESTOREDATA *pSaveData, const char *pname, void *pBaseData, TYPEDESCRIPTION *pFields, int fieldCount )
{
   return;
}

void SaveReadFields( SAVERESTOREDATA *pSaveData, const char *pname, void *pBaseData, TYPEDESCRIPTION *pFields, int fieldCount )
{
   return;
}

void SaveGlobalState( SAVERESTOREDATA *pSaveData )
{
   return;
}

void RestoreGlobalState( SAVERESTOREDATA *pSaveData )
{
   return;
}

void ResetGlobalState( void )
{
   return;
}

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{ 
   return (*pFakeDLLFunctionTable.pfnClientConnect)(pEntity, pszName, pszAddress, szRejectReason);
}

void ClientDisconnect( edict_t *pEntity )
{
   return;
}

void ClientKill( edict_t *pEntity )
{
   return;
}

void ClientPutInServer( edict_t *pEntity )
{
   (*pFakeDLLFunctionTable.pfnClientPutInServer)(pEntity);
}

void ClientCommand( edict_t *pEntity )
{
   int cnt, index;

   if (!master_MasterFakeClientCommand)
   {
      master_MasterFakeClientCommand = (MASTERFAKECLIENTCOMMAND)GetProcAddress(h_Library, "MasterFakeClientCommand");

      if (master_MasterFakeClientCommand == NULL)
      {
         // Can't find MasterFakeClientCommand!

         ALERT( at_error, "fakedll - Can't get BotMixer's GiveBotFnptrsToMaster!" );
         printf("fakedll - Can't get BotMixer's GiveBotFnptrsToMaster!\n" );
         Sleep(5000);
         exit(0);
      }
   }

   cnt = (*g_engfuncs.pfnCmd_Argc)();

   g_argv[0] = 0;

   for (index = 0; index < cnt; )
   {
      strcat(g_argv, (*g_engfuncs.pfnCmd_Argv)(index));

      index++;

      if (index < cnt)
         strcat(g_argv, " ");
   }

   (*master_MasterFakeClientCommand)(pEntity, g_argv);

   return;
}

void ClientUserInfoChanged( edict_t *pEntity, char *infobuffer )
{
   return;
}

void ServerActivate( edict_t *pEdictList, int edictCount, int clientMax )
{
   return;
}

void ServerDeactivate( void )
{
   return;
}

void PlayerPreThink( edict_t *pEntity )
{
   return;
}

void PlayerPostThink( edict_t *pEntity )
{
   return;
}

void StartFrame( void )
{
   return;
}

void ParmsNewLevel( void )
{
   return;
}

void ParmsChangeLevel( void )
{
   return;
}

const char *GetGameDescription( void )
{
   return NULL;
}

void PlayerCustomization( edict_t *pEntity, customization_t *pCust )
{
   return;
}

void SpectatorConnect( edict_t *pEntity )
{
   return;
}

void SpectatorDisconnect( edict_t *pEntity )
{
   return;
}

void SpectatorThink( edict_t *pEntity )
{
   return;
}

void Sys_Error( const char *error_string )
{
   return;
}

void PM_Move ( struct playermove_s *ppmove, int server )
{
   return;
}

void PM_Init ( struct playermove_s *ppmove )
{
   return;
}

char PM_FindTextureType( char *name )
{
   return NULL;
}

void SetupVisibility( edict_t *pViewEntity, edict_t *pClient, unsigned char **pvs, unsigned char **pas )
{
   return;
}

void UpdateClientData ( const struct edict_s *ent, int sendweapons, struct clientdata_s *cd )
{
   (*pFakeDLLFunctionTable.pfnUpdateClientData)(ent, sendweapons, cd);
}

int AddToFullPack( struct entity_state_s *state, int e, edict_t *ent, edict_t *host, int hostflags, int player, unsigned char *pSet )
{
   return 0;
}

void CreateBaseline( int player, int eindex, struct entity_state_s *baseline, struct edict_s *entity, int playermodelindex, vec3_t player_mins, vec3_t player_maxs )
{
   return;
}

void RegisterEncoders( void )
{
   return;
}

int GetWeaponData( struct edict_s *player, struct weapon_data_s *info )
{
   return (*pFakeDLLFunctionTable.pfnGetWeaponData)(player, info);
}

void CmdStart( const edict_t *player, const struct usercmd_s *cmd, unsigned int random_seed )
{
   (*pFakeDLLFunctionTable.pfnCmdStart)(player, cmd, random_seed);
}

void CmdEnd ( const edict_t *player )
{
   (*pFakeDLLFunctionTable.pfnCmdEnd)(player);
}

int ConnectionlessPacket( const struct netadr_s *net_from, const char *args, char *response_buffer, int *response_buffer_size )
{
   return 0;
}

int GetHullBounds( int hullnumber, float *mins, float *maxs )
{
   return 0;
}

void CreateInstancedBaselines( void )
{
   return;
}

int InconsistentFile( const edict_t *player, const char *filename, char *disconnect_message )
{
   return 0;
}

int AllowLagCompensation( void )
{
   return 0;
}


DLL_FUNCTIONS gFunctionTable =
{
   GameDLLInit,               //pfnGameInit
   DispatchSpawn,             //pfnSpawn
   DispatchThink,             //pfnThink
   DispatchUse,               //pfnUse
   DispatchTouch,             //pfnTouch
   DispatchBlocked,           //pfnBlocked
   DispatchKeyValue,          //pfnKeyValue
   DispatchSave,              //pfnSave
   DispatchRestore,           //pfnRestore
   DispatchObjectCollsionBox, //pfnAbsBox

   SaveWriteFields,           //pfnSaveWriteFields
   SaveReadFields,            //pfnSaveReadFields

   SaveGlobalState,           //pfnSaveGlobalState
   RestoreGlobalState,        //pfnRestoreGlobalState
   ResetGlobalState,          //pfnResetGlobalState

   ClientConnect,             //pfnClientConnect
   ClientDisconnect,          //pfnClientDisconnect
   ClientKill,                //pfnClientKill
   ClientPutInServer,         //pfnClientPutInServer
   ClientCommand,             //pfnClientCommand
   ClientUserInfoChanged,     //pfnClientUserInfoChanged
   ServerActivate,            //pfnServerActivate
   ServerDeactivate,          //pfnServerDeactivate

   PlayerPreThink,            //pfnPlayerPreThink
   PlayerPostThink,           //pfnPlayerPostThink

   StartFrame,                //pfnStartFrame
   ParmsNewLevel,             //pfnParmsNewLevel
   ParmsChangeLevel,          //pfnParmsChangeLevel

   GetGameDescription,        //pfnGetGameDescription    Returns string describing current .dll game.
   PlayerCustomization,       //pfnPlayerCustomization   Notifies .dll of new customization for player.

   SpectatorConnect,          //pfnSpectatorConnect      Called when spectator joins server
   SpectatorDisconnect,       //pfnSpectatorDisconnect   Called when spectator leaves the server
   SpectatorThink,            //pfnSpectatorThink        Called when spectator sends a command packet (usercmd_t)

   Sys_Error,                 //pfnSys_Error          Called when engine has encountered an error

   PM_Move,                   //pfnPM_Move
   PM_Init,                   //pfnPM_Init            Server version of player movement initialization
   PM_FindTextureType,        //pfnPM_FindTextureType

   SetupVisibility,           //pfnSetupVisibility        Set up PVS and PAS for networking for this client
   UpdateClientData,          //pfnUpdateClientData       Set up data sent only to specific client
   AddToFullPack,             //pfnAddToFullPack
   CreateBaseline,            //pfnCreateBaseline        Tweak entity baseline for network encoding, allows setup of player baselines, too.
   RegisterEncoders,          //pfnRegisterEncoders      Callbacks for network encoding
   GetWeaponData,             //pfnGetWeaponData
   CmdStart,                  //pfnCmdStart
   CmdEnd,                    //pfnCmdEnd
   ConnectionlessPacket,      //pfnConnectionlessPacket
   GetHullBounds,             //pfnGetHullBounds
   CreateInstancedBaselines,  //pfnCreateInstancedBaselines
   InconsistentFile,          //pfnInconsistentFile
   AllowLagCompensation,      //pfnAllowLagCompensation
};


extern "C" EXPORT int GetEntityAPI( DLL_FUNCTIONS *pFunctionTable, int interfaceVersion )
{
   // check if engine's pointer is valid and version is correct...

   if ( !pFunctionTable || interfaceVersion != INTERFACE_VERSION )
      return FALSE;

   // pass engine callback function table to engine...
   memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );

   master_GetFakeDLLEntityAPI = (GETENTITYAPI)GetProcAddress(h_Library, "GetFakeDLLEntityAPI");

   if (master_GetFakeDLLEntityAPI == NULL)
   {
      // Can't find GetEntityAPI!

      ALERT( at_error, "fakedll - Can't get BotMixer5000 GetFakeDLLEntityAPI!" );
      printf("fakedll - Can't get BotMixer5000 GetFakeDLLEntityAPI!\n");
      Sleep(5000);
      exit(0);
   }

   // save the BotMixer5000 function pointers to the MODs DLL functions...
   (*master_GetFakeDLLEntityAPI)(&pFakeDLLFunctionTable, interfaceVersion);

   return TRUE;
}


extern "C" EXPORT int GetNewDLLFunctions( NEW_DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
   return TRUE;
}


extern "C" EXPORT void player( entvars_t *pev ) 
{
   static LINK_ENTITY_FUNC master_player = NULL;

   if (master_player == NULL)
      master_player = (LINK_ENTITY_FUNC)GetProcAddress(h_Library, "master_player");
   if (master_player != NULL)
      (*master_player)(pev);
   else
   {
      ALERT( at_error, "fakedll - Can't get master_player!" );
      printf("fakedll - Can't get master_player!\n");
      Sleep(5000);
      exit(0);
   }
}

