#include <stdio.h>

// test to make sure files are the same size.
//
// usage: filesize file1 file2
//
// returns: MS-DOS ERRORLEVEL = 0 if not same, ERRORLEVEL = 1 if same size

int main(int argc, char *argv[])
{
   FILE *fp;
   long size1, size2;

   if ((fp=fopen(argv[1],"rb"))==NULL)
   {
      printf("File \"%s\" open error!\n", argv[1]);
      return 0;
   }

   fseek(fp, 0L, SEEK_END);
   size1 = ftell(fp);
   fclose(fp);

   if ((fp=fopen(argv[2],"rb"))==NULL)
   {
      printf("File \"%s\" open error!\n", argv[2]);
      return 0;
   }

   fseek(fp, 0L, SEEK_END);
   size2 = ftell(fp);
   fclose(fp);

   if (size1 == size2)
      return 1;

   return 0;
}

